<?php
  // Guylain Plante, 18 février 2017
  // Exemple de page en PHP pour recevoir et enregistrer les données reçues de la station météo.
  // Voir commentaires un peu partout dans le programme pour plus d'informations.

  define('csENCODING_CHARSET','UTF-8');
  define('ciMETEO_CMD_STATUS_ERROR',0);
  define('ciMETEO_CMD_STATUS_SUCCESS',1);
  define('ciMETEO_VALUE_OUT_OF_BOUNDS',254);  
  define('csUPLOAD_DATA_PASSWORD', '123456');  //Mettre le même mot de passe que dans le programme Arduino
  define('csSENSOR_VALUES_RECORD_LENGTH',10);  // Vitesse vent = 3 caracteres ("xx0" à "999"), Direction vent = 1 caractere ("0" à "7"), Temperature = 3 caracteres ("-99" à "x99"), Vent vitesse maximum atteinte = 3 caracteres ("xx0" à "999") (x = SENSOR_VALUES_RECORD_PADDING_CHARACTER)
  define('csSENSOR_VALUES_RECORD_PADDING_CHARACTER',"x"); 
  define('ciSENSOR_VALUES_DIMENSION_VENT_VITESSE',0);
  define('ciSENSOR_VALUES_DIMENSION_VENT_DIRECTION',1);
  define('ciSENSOR_VALUES_DIMENSION_TEMPERATURE',2);
  define('ciSENSOR_VALUES_DIMENSION_VENT_VITESSE_MAXIMUM',3);
  define('ciSENSOR_VALUES_DIMENSION_DATETIME',99);
  define('csCRLF',chr(13) . chr(10));  
  
  $sys_timezone    = "America/New_York";
  $response        = "R=".ciMETEO_CMD_STATUS_ERROR."".csCRLF."";
  $response_status = ciMETEO_CMD_STATUS_ERROR;
  $sMettrx         = "";
  $fVoltage        = 0.0;
  $iMemory         = 0;
  $iDelayBetweenTx = 0;
  $iTransmissionId = 0;
  
  $aMettrx_1 = array();
  $aMettrx_2 = array();

  $d = new DateTime();
  $d->setTimezone(new DateTimeZone($sys_timezone));
  $offset_user = $d->format('Z');
  $timestamp = $d->format('U') + $offset_user;
  $currentUnixTimeStamp = $timestamp;

  $param_data = "";
  if (isset($_REQUEST["data"])) {
    $param_data = trim($_REQUEST["data"]);
  }

  $param_pwd = "";
  if (isset($_REQUEST["pwd"])) {
    $param_pwd = trim($_REQUEST["pwd"]);
  }
  
  if (trim($param_pwd) == csUPLOAD_DATA_PASSWORD) { //Si le mot de passe est valide

     //Example d'appel de la station météo: http://www.votre-site-web/page1.php?data=xx04-49xx3xx04-49xx3xx04-49xx3V4.232M734D120T87&pwd=123456
     $pos_V = mb_stripos($param_data, "V");
     if ($pos_V == TRUE) {

       $sMettrx = mb_substr($param_data, 0, $pos_V);
       $pos_M   = mb_stripos($param_data, "M");
       $pos_D   = mb_stripos($param_data, "D");
       $pos_T   = mb_stripos($param_data, "T");

       if ($pos_D == TRUE) {
         $fVoltage         = (float) mb_substr($param_data, $pos_V + 1, ($pos_M + 1) - $pos_V);
         $iMemory          = (int)   mb_substr($param_data, $pos_M + 1, ($pos_D + 1) - $pos_M);
         $iDelayBetweenTx  = (int)   mb_substr($param_data, $pos_D + 1, ($pos_T + 1) - $pos_D);
         $iTransmissionId  = (int)   mb_substr($param_data, $pos_T + 1);
       }

       //Si la longeur de $sMettrx n'est pas un multiple de csSENSOR_VALUES_RECORD_LENGTH, il y a quelque chose qui cloche donc on arrête ca là.
       $len = mb_strlen($sMettrx);
       if (($len % csSENSOR_VALUES_RECORD_LENGTH) == 0) {
         for ($index = 0; $index < $len; $index = $index + csSENSOR_VALUES_RECORD_LENGTH) {
          $aMettrx_1[] = mb_substr($sMettrx, $index, csSENSOR_VALUES_RECORD_LENGTH);
         }

         $count_aMettrx_1 = count($aMettrx_1);

         foreach ($aMettrx_1 as $key => $value) {
          $s_ventVitesse    = str_replace(csSENSOR_VALUES_RECORD_PADDING_CHARACTER,"",mb_substr($value, 0, 3));
          $s_ventDirection  = mb_substr($value, 3, 1);
          $s_temperature    = str_replace(csSENSOR_VALUES_RECORD_PADDING_CHARACTER,"",mb_substr($value, 4, 3));
          $s_ventVitesseMax = str_replace(csSENSOR_VALUES_RECORD_PADDING_CHARACTER,"",mb_substr($value, 7, 3));

          $i_ventVitesse   = (int)$s_ventVitesse; 
          if ( ($i_ventVitesse < 0) || ($i_ventVitesse > 250) ) {
           $i_ventVitesse = ciMETEO_VALUE_OUT_OF_BOUNDS;
          }

          $i_ventDirection = (int)$s_ventDirection;
          if ( ($i_ventDirection < 0) || ($i_ventDirection > 7) ) {
           $i_ventDirection = ciMETEO_VALUE_OUT_OF_BOUNDS;
          }

          $i_temperature   = (int)$s_temperature;
          if ( ($i_temperature < -99) || ($i_temperature > 99) ) {
           $i_temperature = ciMETEO_VALUE_OUT_OF_BOUNDS;
          }

          $i_ventVitesseMax   = (int)$s_ventVitesseMax; 
          if ( ($i_ventVitesseMax < 0) || ($i_ventVitesseMax > 250) ) {
           $i_ventVitesseMax = ciMETEO_VALUE_OUT_OF_BOUNDS;
          }

          $aMettrx_2[] = array( 
                               ciSENSOR_VALUES_DIMENSION_VENT_VITESSE         => $i_ventVitesse, 
                               ciSENSOR_VALUES_DIMENSION_VENT_DIRECTION       => $i_ventDirection,
                               ciSENSOR_VALUES_DIMENSION_TEMPERATURE          => $i_temperature,
                               ciSENSOR_VALUES_DIMENSION_DATETIME             => $currentUnixTimeStamp - ((($count_aMettrx_1 - 1) - $key) * $iDelayBetweenTx), //On sait que chaque transaction qu'on recoit a été prise à un interval précis qu'on a recu et mis dans la variable $iDelayBetweenTx. La premiere transaction de l'array est la transaction la plus ancienne.
                               ciSENSOR_VALUES_DIMENSION_VENT_VITESSE_MAXIMUM => $i_ventVitesseMax
                              );

         }

         // Lorsque la station météo appelle cette page, elle lui envoi un numéro de transmission unique. 
         // Si la page enregistre les transactions dans la base de données correctement, celle-ci va retourner 1 
         // comme valeur de retour. Ceci indique à la station météo que l’enregistrement s’est fait avec succès. 
         // Dans un tel cas, la prochaine fois que la station va appeler cette page, ce sera avec un nouveau 
         // numéro de transmission différent. Sinon, si la réponse était 0, et bien ceci indique que la page 
         // n’a pas pu enregistrer les données reçues donc la station météo va réessayer de réenvoyer 
         // les mêmes données une minute plus tard donc elle va utiliser le même numéro de transmission.

         // Notez que lorsque vous démarrez la station météo, la station météo n'attend pas d'avoir 5 transactions pour accède à cette page.
         // Elle accède à cette page immédiatement après avoir une seule transaction. Elle accède cette page avec un numéro 
         // de transmission à 0. Dans un tel cas, la page ne fait rien et retourne 0 pour indiquer que les transactions 
         // n’ont pas pu être enregistrées. Par contre, la page retourne également la date et heure en cours. 
         // C’est à partir de cette date et heure que la station météo peut générer un numéro de transaction unique. 
         // Donc, une fois que la station connaît la date et heure en cours, elle peut ensuite envoyer les données 
         // à cette page au 10 minutes avec un numéro de transmission valide.

         if ($iTransmissionId > 0) {
          // Si il y a dejà des transactions météo de déjà présente dans la base de données avec le même numéro 
          // que le numéro de transmission reçu et bien elles se font effacées systématiquement.
          // Ceci veut dire que les transactions météo avaient bien été enregistrées mais pour une raison
          // quelquonque, la station météo n'avait pas reçue la réponse de la page web.
          // Le but ici est de s'assurer de ne pas avoir de transactions en double dans la base de données tout simplement.

          // *********************************************************************
          // Insérer le code pour effacer les transactions météo dans la base de données 
          // qui ont un numéro de transmission identique à $iTransmissionId
          // *********************************************************************

         }

         //Maintenant on peut enregistrer les transactions météo dans votre base de données
         if ( (count($aMettrx_2) > 0) && ($iTransmissionId> 0) ) { //Patch. Si $iTransmissionId == 0 et bien on retourne une erreur pour forcer l'Arduino et réenvoyer ses donnees une minute plus tard donc on n'enregistre pas les donness recues pour rien.

          foreach ($aMettrx_2 as $key => $value) {

           $pi_timestamp                = $value[ciSENSOR_VALUES_DIMENSION_DATETIME];
           $date                        = new DateTime("@$pi_timestamp");
           $mettrx_datetime             = $date->format('Y-m-d H:i:s');
           $mettrx_vent_vitesse_moyenne = $value[ciSENSOR_VALUES_DIMENSION_VENT_VITESSE];
           $mettrx_vent_vitesse_maximum = $value[ciSENSOR_VALUES_DIMENSION_VENT_VITESSE_MAXIMUM];
           $mettrx_vent_direction       = $value[ciSENSOR_VALUES_DIMENSION_VENT_DIRECTION];
           $mettrx_vent_temperature     = $value[ciSENSOR_VALUES_DIMENSION_TEMPERATURE];

           // $mettrx_datetime             contient la date et heure de la transaction
           // $mettrx_vent_vitesse_moyenne contient la vitesse moyenne
           // $mettrx_vent_vitesse_maximum contient la vitesse maximum atteinte
           // $mettrx_vent_direction       contient la provenance du vent
           // $mettrx_vent_temperature     contient la température

           // *********************************************************************
           // Insérer le code pour enregistrer vos données ici
           // *********************************************************************
           //echo "\$mettrx_datetime=$mettrx_datetime \$mettrx_vent_vitesse_moyenne=$mettrx_vent_vitesse_moyenne \$mettrx_vent_vitesse_maximum=$mettrx_vent_vitesse_maximum \$mettrx_vent_direction=$mettrx_vent_direction \$mettrx_vent_temperature=$mettrx_vent_temperature<br>";
          }

          // Si vous avez correctement enregistré les transactions dans la base de données et bien la réponse 
          // que vous devez retourner à la station météo est 1 au lieu de 0.
          $response_status = ciMETEO_CMD_STATUS_SUCCESS;

         }

         // En plus d'enregistrer chaque transaction météo, il peut être intéressant d'enregistrer 
         // également certaines autres informations recues comme par exemple le voltage de la batterie
         // ou la mémoire disponible dans l'Arduino pour voir si il n'y aurait pas une 
         // faille dans le programme qui gruge la mémoire petit à petit.
         $pi_timestamp    = $currentUnixTimeStamp;
         $date            = new DateTime("@$pi_timestamp");
         $devtrx_datetime = $date->format('Y-m-d H:i:s');

         // $devtrx_datetime             contient la date et heure en cours
         // $fVoltage                    contient le voltage de la batterie
         // $iMemory                     contient la mémoire disponible (en octets)

         // *********************************************************************
         // Insérer le code pour enregistrer vos données ici
         // *********************************************************************
         //echo "\$devtrx_datetime=$devtrx_datetime \$fVoltage=$fVoltage \$iMemory=$iMemory<br>";

         // Maintenant on initialise la variable $response. C'est la réponse que la station météo va recevoir
         $d             = new DateTime();
         $d->setTimezone(new DateTimeZone($sys_timezone));
         $offset_user   = $d->format('Z');
         $timestamp     = $d->format('U') + $offset_user;

         $response     = "R=$response_status".csCRLF."DT=$timestamp".csCRLF."MSG=Bonne journee!";
        }
     }
            
      
  } else {
   //Mauvais mot de passe
   //echo "Mauvais mot de passe<br>";
  }

  //Affichage de la réponse (C'est ce que la station recoit comme réponse)
  die("$response"); 
  
?>
